VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "codebarre"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior = 0   'vbNone
  MTSTransactionMode = 0   'NotAnMTSObject
End


'22.09.05
' Transformation VB (.exe) -> VB (.dll, .exp, .lib) pour importation dans crystal reports 8.x, 9.x, 10.x, 11
'Sbastien Rez

' UFL Code  Barre 128 pour Crystal Reports
' Les fichiers Gnrs :
'           - CRUFL128.dll
'           - CRUFL128.exp
'           - CRUFL128.lib
' sont  copis dans le rpertoire Crystal reports situ dans Program Files.

' Il faut imprativement utiliser la Police code128.ttf disponible sur le site http://grandzebu.net/
' Cette police a t crer par GrandZebu et fonctionne  merveille. (Test OK avec douchette LS3000 de chez Symbol)


'Mode d'emploi :
'La nouvelle fonction (code128()) se trouve dans les fonctions supplmentaires
'de l'diteur de formule dans crystal reports.

Option Explicit
Public UFPrefixFunctions As Boolean
Public i, checksum, mini, dummy, tableB As Boolean

Private Sub Class_Initialize()
UFPrefixFunctions = False
End Sub

Public Function Code128(chaine As String) As String
  'V 2.0
  'Paramtres : une chaine
  'Retour : * une chaine qui, affiche avec la police CODE128.TTF, donne le code barre
  '         * une chaine vide si paramtre fourni incorrect
  Code128 = ""
  If Len(chaine) > 0 Then
  'Vrifier si caractres valides
    For i = 1 To Len(chaine)
      Select Case Asc(Mid$(chaine, i, 1))
      Case 32 To 126
      Case Else
        i = 0
        Exit For
      End Select
    Next
    'Calculer la chaine de code en optimisant l'usage des tables B et C
    Code128 = ""
    tableB = True
    If i > 0 Then
      i = 1 'i devient l'index sur la chaine
      Do While i <= Len(chaine)
        If tableB Then
          'Voir si intressant de passer en table C
          'Oui pour 4 chiffres au dbut ou  la fin, sinon pour 6 chiffres
          mini = IIf(i = 1 Or i + 3 = Len(chaine), 4, 6)
          GoSub testnum
          If mini < 0 Then 'Choix table C
            If i = 1 Then 'Dbuter sur table C
              Code128 = Chr$(210)
            Else 'Commuter sur table C
              Code128 = Code128 & Chr$(204)
            End If
            tableB = False
          Else
            If i = 1 Then Code128 = Chr$(209) 'Dbuter sur table B
          End If
        End If
        If Not tableB Then
          'On est sur la table C, essayer de traiter 2 chiffres
          mini = 2
          GoSub testnum
          If mini < 0 Then 'OK pour 2 chiffres, les traiter
            dummy = Val(Mid$(chaine, i, 2))
            dummy = IIf(dummy < 95, dummy + 32, dummy + 100)
            Code128 = Code128 & Chr$(dummy)
            i = i + 2
          Else 'On n'a pas 2 chiffres, repasser en table B
            Code128 = Code128 & Chr$(205)
            tableB = True
          End If
        End If
        If tableB Then
          'Traiter 1 caractre en table B
          Code128 = Code128 & Mid$(chaine, i, 1)
          i = i + 1
        End If
      Loop
      'Calcul de la cl de contrle
      For i = 1 To Len(Code128)
        dummy = Asc(Mid$(Code128, i, 1))
        dummy = IIf(dummy < 127, dummy - 32, dummy - 100)
        If i = 1 Then checksum = dummy
        checksum = (checksum + (i - 1) * dummy) Mod 103
      Next
      'Calcul du code ASCII de la cl
      checksum = IIf(checksum < 95, checksum + 32, checksum + 100)
      'Ajout de la cl et du STOP
      Code128 = Code128 & Chr$(checksum) & Chr$(211)
    End If
  End If
  Exit Function
testnum:
  'si les mini caractres  partir de i sont numriques, alors mini=0
  mini = mini - 1
  If i + mini <= Len(chaine) Then
    Do While mini >= 0
      If Asc(Mid$(chaine, i + mini, 1)) < 48 Or Asc(Mid$(chaine, i + mini, 1)) > 57 Then Exit Do
      mini = mini - 1
    Loop
  End If
Return

End Function
